#ifndef __STR_FIND_H
#include "str_find.h"
#endif

#ifndef __STRING_H
#include <string.h>
#endif

/*****************************************************************************
*  post_lex.
*  post_lex    :
* *   <Alt+255>[1-7].
* *       <Alt+255>0.
* *       ,   
     <Alt+255>0.
* *   <Alt+255>_ .
* *       <Alt+255>. .
* *       ,   
     <Alt+255>. .
* *  .
*
*  :
 *
 *  : UCHAR *stringz -- ,    ,
 *                    int *n --  .
 *
 *  : E_OK   .
 *    :
 *                              E_BAD_STR
 *                              E_BAD_SUBSTR
 *                              E_BAD_NUM
 *                              E_BAD_MEMORY_HEAP
 *
*
***************************************************************************/
int post_lex_strn( UCHAR *stringz, int *n)
{
  int iCol, iCond, il2, ierr;
  UCHAR cc, cd[2]={0xff,0x00};
/*  */
  iCond=0;
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   [1-7] */
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto ERROR;
    cc=stringz[++iCol];
/*-----------------06/11/03 19:23-------------------
    0
--------------------------------------------------*/
    if( iCond == 0 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,    .
--------------------------------------------------*/
	  case '1' :
	  case '2' :
	  case '3' :
	  case '4' :
	  case '5' :
    case '6' :
	  case '7' :
    case '8' :
    case '9' :
	    iCond = 1;
	    goto B1;
/*-----------------06/11/03 19:26-------------------
   --    ,   
--------------------------------------------------*/
	  case '0' :
/*    -- 0,    . */
	    {
	      if( (ierr = istrDelete( stringz, --iCol, 2,  *n ) ) != E_OK )
	      {
		iCol = ierr; goto ERROR;
	      }
	      goto B1;
	    }
/*-----------------06/11/03 19:29-------------------
   ,   .
--------------------------------------------------*/
	  default:
	    goto B1;
      }
/*-----------------06/11/03 19:30-------------------
    --  :
--------------------------------------------------*/
     else if (iCond == 1 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,   
 '   '.
--------------------------------------------------*/
	  case '1' :
	  case '2' :
	  case '3' :
	  case '4' :
	  case '5' :
    case '6' :
	  case '7' :
    case '8' :
    case '9' :
	    {
	      if( (ierr = istrInsert( stringz, (UCHAR *)"\xff\x30", --iCol,  *n)  ) != E_OK )
	      {
		iCol = ierr; goto ERROR;
	      }
	      iCol +=3;
	      goto B1;
	    }
/*-----------------06/11/03 19:26-------------------
   --    ,   .
--------------------------------------------------*/
	  case '0' :
/*    -- 0,    . */
	      iCond = 0;
	      goto B1;
	default:
	  goto B1;
      }
    else goto ERROR;
    B1:;
  }
/*   [1-7] */
  if( iCond == 1 )
  {
    stringz[strlen((const char *)stringz)-1] = '\0';
    strncat( (char *)stringz, "\xff\x30\n", *n );
  }
/*       . */
/*  */
  iCond=0;
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   [_.] */
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto ERROR;
    cc=stringz[++iCol];
/*-----------------06/11/03 19:23-------------------
    .
--------------------------------------------------*/
    if( iCond == 0 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,    .
--------------------------------------------------*/
    case '_' :
	    iCond = 1;
	    goto B2;
/*-----------------06/11/03 19:26-------------------
   --    ,   
--------------------------------------------------*/
    case '.' :
/*    -- 0,    . */
	    {
	      if( (ierr = istrDelete( stringz, --iCol, 2,  *n ) ) != E_OK )
	      {
		iCol = ierr; goto ERROR;
	      }
	      goto B2;
	    }
/*-----------------06/11/03 19:29-------------------
   ,   .
--------------------------------------------------*/
	  default:
	    goto B2;
      }
/*-----------------06/11/03 19:30-------------------
    -- _:
--------------------------------------------------*/
     else if (iCond == 1 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,   
 '   '.
--------------------------------------------------*/
    case '_' :
	    {
        if( (ierr = istrInsert( stringz, (UCHAR *)"\xff\x2e", --iCol,  *n)  ) != E_OK )
	      {
		iCol = ierr; goto ERROR;
	      }
	      iCol +=3;
	      goto B2;
	    }
/*-----------------06/11/03 19:26-------------------
   --    ,   .
--------------------------------------------------*/
    case '.' :
/*    -- 0,    . */
	      iCond = 0;
	      goto B2;
	default:
	  goto B2;
      }
    else goto ERROR;
    B2:;
  }
/*   [1-7] */
  if( iCond == 1 )
  {
    stringz[strlen((const char *)stringz)-1] = '\0';
    strncat( (char *)stringz, "\xff\x2e\n", *n );
  }
/*   [.] */
  return E_OK;
/* ,   */
    ERROR:
  return iCol;
/*   */
}
