/********************************************************************
 *
 *      GNU GCC.
 *
********************************************************************/

/**********************************************************
 *
 *       
 *  - "" .   
 *     , 
 *    .
 *
 * Copyleft 2005-2007  .  (yudenisov) All Rirgt Reserved.
 * Version 1.01.
 *
***********************************************************/

#ifndef __SIMPSCAN_H
#include "simpscan.h"
#endif

/***********************************************************
 *
 * Function sValid_Word_s
 *
 *      main_str,   index,
 *      newstr,
 *       
 * (  )    
 *      .
 *
 *  
 *   new_str    --  ,    ;
 *   main_str   --    ;
 *   index      --     .
 *
 *  
 *   E_OK 		--    ;
 *   E_BAD_MEMORY_HEAP  --      ;
 *   E_BAD_NUM          --  ,    .
 *
 *  :
 *   calloc, memset, is_valid_symbol
 *
***********************************************************/

short sValid_Word_s( UCHARS **str, UCHARS *main_str, int *index )
{
	UCHARS cValid_symbol;
	UCHARS *new_str = NULL;

	int i;

 /*     WORD_SIZE (30 ) */

  if( (new_str = (UCHARS *) calloc( WORD_SIZE, sizeof( UCHARS ))) == NULL)
  {
	*str = new_str;
	return E_BAD_MEMORY_HEAP;
  }

 /*      */

	memset( (char *)new_str, '\0', WORD_SIZE );

 /*     main_str,  */
 /* E_BAD_NUM,   new_str  */

     if( *index > NEW_STR_LENGTH)
	{
		free( new_str );
		*str = new_str;
		return E_BAD_NUM;
	}

	if( main_str[*index] == '\0')
	{
		free( new_str );
		*str = new_str;
		return E_BAD_NUM;
	}

 /*   main_str      */
 /* NEW_STR_LENGTH */

	for( i=0; i < NEW_STR_LENGTH, main_str[*index]; i++ )
	{


 /*     *index  . */
 /*   ,      i */
 /*  new_str.    */
 /*    E_OK ( ) */

	    cValid_symbol = is_valid_symbol( *index, main_str );
	    (*index)++;
	    if( cValid_symbol )
		 new_str[i] = cValid_symbol;
	    else
	    {
		*str = new_str;
		return E_OK;
	    }
	}

	*str = new_str;
	return E_OK;

 /*  .    new_str */

}

/***********************************************************
 *
 * Function sValid_Word
 *
 *      main_str,   index,
 *      newstr,
 *       
 * (  )    
 *      .
 *
 *  
 *   new_str    --  ,    ;
 *   main_str   --    ;
 *   index      --     .
 *   ilanguage  --  
 *   iCode_Tab  --   (   )
 *
 *  
 *   E_OK 		--    ;
 *   E_BAD_MEMORY_HEAP  --      ;
 *   E_BAD_NUM          --  ,    .
 *
 *  :
 *   calloc, memset, is_valid_alphabet
 *
 *
***********************************************************/

short sValid_Word( UCHARS **str, UCHARS *main_str, int *index, int ilanguage, int iCode_Tab )
{
	UCHARS cValid_symbol;
	UCHARS *new_str = NULL;

	int i;

 /*     WORD_SIZE */

  if( (new_str = (UCHARS *) calloc( WORD_SIZE, sizeof( UCHARS ))) == NULL)
  {
	*str = new_str;
	return E_BAD_MEMORY_HEAP;
  }

 /*      */

	memset( (char *)new_str, '\0', WORD_SIZE );

 /*     main_str,  */
 /* E_BAD_NUM,   new_str  */

     if( *index > NEW_STR_LENGTH)
	{
		free( new_str );
		*str = new_str;
		return E_BAD_NUM;
	}

	if( main_str[*index] == '\0')
	{
		free( new_str );
		*str = new_str;
		return E_BAD_NUM;
	}

 /*   main_str      */
 /* NEW_STR_LENGTH */

	for( i=0; i < NEW_STR_LENGTH, main_str[*index]; i++ )
	{


 /*     *index  . */
 /*   ,      i */
 /*  new_str.    */
 /*    E_OK ( ) */

	    cValid_symbol = is_valid_alphabet( *index, main_str, ilanguage, iCode_Tab);
	    (*index)++;
	    if( cValid_symbol )
		 new_str[i] = cValid_symbol;
	    else
	    {
		*str = new_str;
		return E_OK;
	    }
	}

	*str = new_str;
	return E_OK;

 /*  .    new_str */

}

/*********************************************************************
 *
 * Function sCopyToWord
 *
 *    WORD_SIZE   , 
 *  sValid_Word_s,     ,  
 *      .
 *
 *  
 *
 *  :
 *
 *  :
 *   calloc, free, memset, strncpy
 *
*********************************************************************/

UCHARS * sCopyToWord( UCHARS *OldStr )
{

 UCHARS *sWord = NULL;

 if( *OldStr != NULL)
 {

    if( (sWord = (UCHARS *) calloc ( WORD_SIZE, sizeof (UCHARS) )) == NULL )
      return NULL;

    memset( (char *)sWord, '\0', WORD_SIZE);

    strncpy( (char *) sWord, (char *) OldStr, WORD_SIZE );

    free( OldStr );
 }

 else
    return NULL;

 return sWord;


}

