/***********************************************************
 *
 * WSTR.H
 *
 * This is a file containing datas, function and definitions
 * for creating the Frequency Dictionary
 *
 *  䠩 ᮤন , । 㭪権  ⠭
 *  ᮧ ணࠬ: " ᫮" ("FreqDict").
 *
***********************************************************/

#ifndef UCHARS
#define UCHARS unsigned char
#endif


#ifndef __WSTR_H
#define __WSTR_H

/* #ifndef __MEM_MODL_H
#include <mem_modl.h>
#endif */

#ifndef __WORDS0_H
#include "words0.h"
#endif

#ifndef __STDIO_H
#include <stdio.h>
#endif

/* ᪫⥫ 樨 */

/***********************************************************
 *
 * Definition the Constants:
 *
 * NOTE: Prefix WWAR_ means that the events is a Warning, and
 * WERR_ means that the events is an Error, other events has
 * prefix W_
 *
 * । ⠭:
 *
 * : 䨪 WWAR_ 砥,   ᮡ⨥ --
 * ।०,  䨪 WERR_ 砥,   ᮡ⨥
 * -- 訡, 㣨 ᮡ  䨪 W_.
 *
***********************************************************/

#ifndef WWAR_OVERFLOW     /* ।०: ९ */
#define WWAR_OVERFLOW 2
#endif

#ifndef WERR_OVERFLOW     /* 訡: ९ */
#define WERR_OVERFLOW -2
#endif

#ifndef WWAR_NOWORDS     /* ।०: ९ */
#define WWAR_NOWORDS 5
#endif

#ifndef WERR_NOWORDS     /* 訡: ९ */
#define WERR_NOWORDS -5
#endif

#ifndef WERR_DAMAGEDATA   /* 訡: ०  */
#define WERR_DAMAGEDATA -3
#endif

#ifndef WERR_DAMAGEARRAY  /* 訡: ० ᨢ */
#define WERR_DAMAGEARRAY -4
#endif

#ifndef W_SUCCESS       /* 襭 ᯥ譮 (All Ok, Mum!)*/
#define W_SUCCESS 0
#endif

#ifndef W_EQUAL         /* 稭 ࠢ */
#define W_EQUAL 0
#endif

#ifndef W_LESS          /* 稭 , 祬... */
#define W_LESS -1
#endif

#ifndef W_GREAT         /* 稭 , 祬... */
#define W_GREAT 1
#endif

/***********************************************************
 *
 * Data sructure of a node of Frecuency Dictionary
 *
 * nIndex is a number of a word in an array;
 * sWord is a current word of an array;
 * nFreq is a frecuency of a word presenting in a text
 * nStatus is a code of speech part of the word
 *
 *    ᨢ " ᫮".
 *
 * nIndex --  ᫮  ᨢ
 * sWord -- ⥪饥 ᫮  ᨢ
 * nFreq --  砥 ᫮  ⥪.
 * nStatus --     ᫮.
 *
***********************************************************/
typedef struct
{
  short nIndex;
  UCHARS sWord[WORD_SIZE];
  short nFreq;
  short nStatus;
} WSTR;

/*********************************************************
 *
 * Functions for operating a Data of a Frecuency
 * Dictionary array
 *
 * 㭪樨  権 묨 ᨢ  ணࠬ
 * " ᫮".
 *
*********************************************************/

/* Describe for C++ only */

#ifdef __cplusplus
extern "C" {
#endif

/* Manipulated with the words */

/*   ᫮ */

int iadd_word( WSTR *, int *, UCHARS * );
int icompare_words_s( WSTR *, int *, int, UCHARS * );
int icompare_words( WSTR *, int *, int, UCHARS *, int, int );
int iadd_freq( WSTR *, int *, int, short );
int ichecking_word_s( WSTR *, int *, UCHARS * );
int ichecking_word( WSTR *, int *, UCHARS *, int, int );

/* Creating/Deleting the Words Frecuency Dictionary array */

/* / ᨢ ᫮ ⭮ ᫮ */

int ienable_create_WSTR( void );
int icreate_WSTR( WSTR ** );
int idelete_WSTR( WSTR ** );

/* Input/Output the array */

/* /뢮 ᨢ */

void PrintTextOn_WSTR( WSTR *, FILE * );

/* Describe for C++ only */

#ifdef __cplusplus
}
#endif

#endif
