/********************************************************************
 *
 *      Inprise/Borland C++.
 *
********************************************************************/

/**********************************************************
 *
 * File RUSENG.H
 *
 * Copyleft Yuri A. Denisov. All Right Reserved.
 * Version 1.00
 *
 * This File is a Header File of Project:
 * "Library for Working with a Russian text"
 *
 * This functions works with:
 *
 * * Russian and Englihs languages
 * * They are support Code Pages CP-866, Windows-1251, KOI-8R
 *   for Russian language and any code pages for English languages
 *
 * The new functions may works with other languages and code pages.
 *
 * All this function read in BORLAND C++, at C and C++ mode
 * with notation
 *
***********************************************************/

/* Define header files identify */

#ifndef __RUSENG_H
#define __RUSENG_H

/* Include external Header Files */

/* Define DATA Types */

#ifndef UCHAR
#define UCHAR unsigned char
#endif

/* Define the constant for choose the languages */

#define LANG_RUS    7           /* Russian language */
#define LANG_USA    1           /* USA language */
#define LANG_ENGLISH  LANG_USA  /* English (USA) language */
#define LANG_UNKNOWN  -32768    /* Unknown language */

/* Define the constant for choose copde page */

/* For Russian Language */

#define CODETAB_1251  1251  /* Windows Code Page CP-1251 */
#define CODETAB_866   866   /* MS-DOS Code Page CP-866 */
#define CODETAB_KOI   -2    /* KOI-8R Code Pages (UNIX) */

/* Describe for C++ only */

#ifdef __cplusplus
extern "C" {
#endif

/* End Describe for C++ */

UCHAR is_valid_symbol( int, UCHAR * );
UCHAR is_valid_alphabet( int, UCHAR *, int, int);
UCHAR cis_rusalphabet( UCHAR, int );
UCHAR cis_engalphabet( UCHAR );
UCHAR cis_ruslower( UCHAR cSymbol, int Code_Tab );
UCHAR cis_rusupper( UCHAR cSymbol, int Code_Tab );
UCHAR cto_ruslower( UCHAR cSymbol, int Code_Tab );
UCHAR cto_rusupper( UCHAR cSymbol, int Code_Tab );


/* Describe for C++ only */

#ifdef __cplusplus
}
#endif

/* End Describe for C++ */

#endif
