
#define STRICT

#ifndef __STR_FIND_H
#include "str_find.h"
#endif

#ifndef __STRING_H
#include <string.h>
#endif

/*****************************************************************************
*  post_lex.
*  post_lex    :
* *   <Alt+255>[1-7].
* *       <Alt+255>0.
* *       ,   
     <Alt+255>0.
* *   <Alt+255>_ .
* *       <Alt+255>. .
* *       ,   
     <Alt+255>. .
* *  .
*
*  :
 *
 *  : HLOCAL hstringz -- ,    ,
 *                    short *n --  .
 *
 *  : E_OK   .
 *    :
 *                              E_BAD_STR
 *                              E_BAD_SUBSTR
 *                              E_BAD_NUM
 *                              E_BAD_MEMORY_HEAP
 *
*
***************************************************************************/
short WINAPI post_lex_strn( HLOCAL *hstringz, short *n)
{
  short iCol, iCond, il2, ierr;
  char cc, cd[2]={0xff,0x00};
  LPSTR stringz, lpszTemp;
  const char szZero[] = "\xff\x30";
  const char szPoshort[] = "\xff\x2e";
  short nLenTextCons;
  HLOCAL hZero, hPoshort;
/*  */
  iCond=0;
  iCol = 0;
  ierr = E_OK;
  nLenTextCons = lstrlen( szZero );
  hZero = LocalAlloc( LHND, nLenTextCons*sizeof( char ) );
  hPoshort = LocalAlloc( LHND, nLenTextCons*sizeof( char ) );
  if( hZero == NULL || hPoshort == NULL ) return E_BAD_MEMORY_HEAP;
  lpszTemp = (LPSTR) LocalLock( hZero );
  if( lpszTemp == NULL )
  {
	(void) LocalFree( hZero );
	(void) LocalFree( hPoshort );
	return E_BAD_MEMORY_HEAP;
  }
  (void) lstrcpyn( lpszTemp, szZero, nLenTextCons );
  (void) LocalUnlock( hZero );
  if( hZero == NULL || hPoshort == NULL ) return E_BAD_MEMORY_HEAP;
  lpszTemp = (LPSTR) LocalLock( hPoshort );
  if( lpszTemp == NULL )
  {
	(void) LocalFree( hZero );
	(void) LocalFree( hPoshort );
	return E_BAD_MEMORY_HEAP;
  }
  (void) lstrcpyn( lpszTemp, szPoshort, nLenTextCons );
  (void) LocalUnlock( hPoshort );
  
  while( iCol < *n )
  {
/*   [1-7] */
	stringz = (LPSTR) LocalLock( hstringz );
	if( stringz == NULL ) 
	{
		(void) LocalFree( hZero );
		(void) LocalFree( hPoshort );
		return E_BAD_MEMORY_HEAP;
	}
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
    cc = stringz[++iCol];
	(void) LocalUnlock( hstringz );
/*-----------------06/11/03 19:23-------------------
    0
--------------------------------------------------*/
    if( iCond == 0 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,    .
--------------------------------------------------*/
	  case '1' :
	  case '2' :
	  case '3' :
	  case '4' :
	  case '5' :
    case '6' :
	  case '7' :
    case '8' :
    case '9' :
	    iCond = 1;
	    goto B1;
/*-----------------06/11/03 19:26-------------------
   --    ,   
--------------------------------------------------*/
	  case '0' :
/*    -- 0,    . */
	    {
	      if( (ierr = istrDelete( hstringz, --iCol, 2,  *n ) ) != E_OK )
	      {
		iCol = ierr; goto LAB_ERROR;
	      }
	      goto B1;
	    }
/*-----------------06/11/03 19:29-------------------
   ,   .
--------------------------------------------------*/
	  default:
	    goto B1;
      }
/*-----------------06/11/03 19:30-------------------
    --  :
--------------------------------------------------*/
     else if (iCond == 1 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,   
 '   '.
--------------------------------------------------*/
	  case '1' :
	  case '2' :
	  case '3' :
	  case '4' :
	  case '5' :
    case '6' :
	  case '7' :
    case '8' :
    case '9' :
	    {
	      if( (ierr = istrInsert( hstringz, hZero, --iCol,  *n)  ) != E_OK )
	      {
		iCol = ierr; goto LAB_ERROR;
	      }
	      iCol +=3;
	      goto B1;
	    }
/*-----------------06/11/03 19:26-------------------
   --    ,   .
--------------------------------------------------*/
	  case '0' :
/*    -- 0,    . */
	      iCond = 0;
	      goto B1;
	default:
	  goto B1;
      }
    else goto LAB_ERROR;
    B1:;
  }
/*   [1-7] */
  if( iCond == 1 )
  {
	stringz = (LPSTR) LocalLock( hstringz );
	if( stringz == NULL ) 
	{
		(void) LocalFree( hZero );
		(void) LocalFree( hPoshort );
		return E_BAD_MEMORY_HEAP;
	}
    stringz[lstrlen((LPCSTR)stringz)-1] = '\0';
    lstrcat( (LPSTR)stringz, "\xff\x30\n" );
	(void) LocalUnlock( hstringz );
  }
/*       . */
/*  */
  iCond=0;
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   [_.] */
	stringz = (LPSTR) LocalLock( hstringz );
	if( stringz == NULL ) 
	{
		(void) LocalFree( hZero );
		(void) LocalFree( hPoshort );
		return E_BAD_MEMORY_HEAP;
	}
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
    cc=stringz[++iCol];
	(void) LocalUnlock( hstringz );
/*-----------------06/11/03 19:23-------------------
    .
--------------------------------------------------*/
    if( iCond == 0 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,    .
--------------------------------------------------*/
    case '_' :
	    iCond = 1;
	    goto B2;
/*-----------------06/11/03 19:26-------------------
   --    ,   
--------------------------------------------------*/
    case '.' :
/*    -- 0,    . */
	    {
	      if( (ierr = istrDelete( hstringz, --iCol, 2,  *n ) ) != E_OK )
	      {
		iCol = ierr; goto LAB_ERROR;
	      }
	      goto B2;
	    }
/*-----------------06/11/03 19:29-------------------
   ,   .
--------------------------------------------------*/
	  default:
	    goto B2;
      }
/*-----------------06/11/03 19:30-------------------
    -- _:
--------------------------------------------------*/
     else if (iCond == 1 )
      switch( cc )
      {
/*-----------------06/11/03 19:25-------------------
   --  ,   
 '   '.
--------------------------------------------------*/
    case '_' :
	    {
        if( (ierr = istrInsert( hstringz, hPoshort, --iCol,  *n)  ) != E_OK )
	      {
		iCol = ierr; goto LAB_ERROR;
	      }
	      iCol +=3;
	      goto B2;
	    }
/*-----------------06/11/03 19:26-------------------
   --    ,   .
--------------------------------------------------*/
    case '.' :
/*    -- 0,    . */
	      iCond = 0;
	      goto B2;
	default:
	  goto B2;
      }
    else goto LAB_ERROR;
    B2:;
  }
/*   [1-7] */
  if( iCond == 1 )
  {
	stringz = (LPSTR) LocalLock( hstringz );
	if( stringz == NULL ) 
	{
		(void) LocalFree( hZero );
		(void) LocalFree( hPoshort );
		return E_BAD_MEMORY_HEAP;
	}
    stringz[lstrlen((LPCSTR)stringz)-1] = '\0';
    strncat( (LPSTR)stringz, "\xff\x2e\n", *n );
  }
  LocalUnlock( hstringz );
/*   [.] */
  (void) LocalFree( hZero );
  (void) LocalFree( hPoshort );
  return E_OK;
/* ,   */
    LAB_ERROR:
  (void) LocalFree( hZero );
  (void) LocalFree( hPoshort );
  return iCol;
/*   */
}
