#ifndef __STR_FIND_H
#include "str_find.h"
#endif

#define STRICT

#ifndef __MEM_H
#include <mem.h>
#endif

#ifndef __WINDOWS_H
#include <windows.h>
#endif

/**********************************************************************
 *  SPEC_C
 *
 *  spec_c    "&", "\"", ">"  "<" 
 *  &amp; &quot; &gt;  &lt; c.
 *    
 *     HTML.
 *
 *  :   LPSTR stringz --  ;
 *                      short *n --  
 *
 *  : E_OK      .
 *
 *********************************************************************/
short WINAPI spec_c( LPSTR stringz, short *n)
{
  short iCol, il2, ierr;
  HLOCAL htemp;
  LPSTR *lpsztemp;

/* ,     */
  iCol = 0;
  ierr = E_OK;
  htemp = LocalAlloc(LHND, (UINT) n*sizeof (char ) );
  if( htemp == NULL ) return E_BAD_MEMORY_HEAP;
  while( iCol < *n )
  {
/*   */
    iCol=istrFind_FWD( stringz, (LPCSTR)"&", iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
/*   */
    ierr=istrRepl( stringz, iCol++, 1, (LPCSTR)"&amp;", *n, &htemp );
/*    htemp */
    if( (lpsztemp = (LPSTR) LocalLock( htemp ) ) == NULL )
    {
	(void) LocalFree( htemp );
      	return E_BAD_MEMORY_HEAP;
    }
    lstrcpyn(stringz, (LPCSTR) lpsztemp, *n );
    memset( lpsztemp, '\0', *n );
    (void) LocalUnlock( htemp );
  }
/* , */
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   */
    iCol=istrFind_FWD( stringz, (LPCSTR)"\"", iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
/*   */
    ierr=istrRepl( stringz, iCol++, 1, (LPCSTR)"&quot;", *n, &htemp );
/*    htemp */
    if( (lpsztemp = (LPSTR) LocalLock( htemp ) ) == NULL )
    {
	(void) LocalFree( htemp );
      	return E_BAD_MEMORY_HEAP;
    }
    lstrcpyn(stringz, (LPCSTR) lpsztemp, *n );
    memset( lpsztemp, '\0', *n );
    (void) LocalUnlock( htemp );
  }
/* , */
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   "" */
    iCol=istrFind_FWD( stringz, (LPCSTR)">", iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
/*   */
    ierr=istrRepl( stringz, iCol++, 1, (LPCSTR)"&gt;", *n, &htemp );
/*    htemp */
    if( (lpsztemp = (LPSTR) LocalLock( htemp ) ) == NULL )
    {
	(void) LocalFree( htemp );
      	return E_BAD_MEMORY_HEAP;
    }
    lstrcpyn(stringz, (LPCSTR) lpsztemp, *n );
    memset( lpsztemp, '\0', *n );
    (void) LocalUnlock( htemp );
  }
/* , */
  iCol = 0;
  ierr = E_OK;
  while( iCol < *n )
  {
/*   "" */
    iCol=istrFind_FWD( stringz, (LPCSTR)"<", iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto LAB_ERROR;
/*   */
    ierr=istrRepl( stringz, iCol++, 1, (LPCSTR)"&lt;", *n, &htemp );
/*    htemp */
    if( (lpsztemp = (LPSTR) LocalLock( htemp ) ) == NULL )
    {
	(void) LocalFree( htemp );
      	return E_BAD_MEMORY_HEAP;
    }
    lstrcpyn(stringz, (LPCSTR) lpsztemp, *n );
    memset( lpsztemp, '\0', *n );
    (void) LocalUnlock( htemp );
  }
  LAB_ERROR:  ierr=iCol;
  return ierr;

}
/*   */
