/********************************************************************
 *
 *      GNU CC.
 *
********************************************************************/

/**********************************************************
 *
 * WORDS0.H
 *
 * Copyleft Yuri A. Denisov. All Right Reserved.
 * Version 1.01.
 *
 * This is a header file containing common definitions
 * the constant for Working with text format.
 *
 * This file contains next blocks of constants
 *
 * * Part of the speech of Russian language;
 * * Part of the speech of English language;
 * * Part of speech both Russian & English languages _WORD_SPEECH;
 * * A Text Data Parameters _WORD_SIZE
 *
 *      
 *      .
 *
 *       :
 *
 * *    .
 * *    .
 * *    ,    .
 * *    _WORD_SIZE
 *
 *         _WORD_tEST.
 *
***********************************************************/

/*     */

/*           #define
#define _WORD_TEST */

/*     */

#ifndef __WORDS0_H
#define __WORDS0_H

/* Part of the speech */
/*    */

#ifndef _WORD_SPEECH
#define _WORD_SPEECH

#define WORD_UNKNOWN     0       /*   () */
#define WORD_NOUN        2       /*  */
#define WORD_AJECTIVE    4       /*  */
#define WORD_NUMERAL     8       /*  */
#define WORD_PRONOUN     16      /*  */
#define WORD_ADVERB      32      /*  */
#define WORD_VERB        64      /*  */
#define WORD_PARTICIPLEJ 68      /*  */
#define WORD_PARTICIPLED 96      /*  */
#define WORD_PREPOSITION 128     /*  */
#define WORD_CONJUNCTION 256     /*  */
#define WORD_OTHER       512     /*    */
#define WORD_NONE        32767   /*   */

#endif

/* Define Data Size*/
/*    */

#ifndef _WORD_SIZE
#define _WORD_SIZE

#ifdef _WORD_TEST

#define WORD_SIZE        10       /*   ( ) */
#define STRING_SIZE      80       /*   ( ) */
#define WORDS_NUM_FILE   8        /*     */ /* Numeric of Words in a file */

#else

#define WORD_SIZE        30       /*   ( ) *//* ????? ????? */
#define STRING_SIZE      750      /*   ( ) */
#define WORDS_NUM_FILE   500      /*     */ /* Numeric of Words in a file */

#endif

#endif

#endif
