/********************************************************************
 *
 *      Inprise/Borland C++.
 *
********************************************************************/

/**********************************************************
 *
 *         ,
 *       
 *   ,     ,
 *  ""      .
 *
 * Copyleft 2005-2007  .  (yudenisov).
 * All Right Reserved.
 * Version 1.01.
 *
***********************************************************/

/*      */
#define STRICT

#ifndef __WSTR_H
#include "wstr.h"
#endif

#ifndef __SIMPSCAN_H
#include "simpscan.h"
#endif

#ifndef __WORDS0_H
#include "words0.h"
#endif

/***********************************************************
 *
 * The function iadd_word add the words into array itenms
 *
 *        
 * " ".
 *
 *  :
 *
 * words        --    , 
 *                 ,   
 *                  ( --  "").
 * iMax         --     "".
 * sWord        --   "" .
 *
 *  :
 * WWAR_OVERFLOW --   -   .
 * W_SECCESS     --     "".
 *
 *  :
 *      strlen
 *
***********************************************************/
#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __STDIO_H
#include <stdio.h>
#endif

#ifndef __STRING_H
#include <string.h>
#endif

#ifndef __MEM_H
#include <mem.h>
#endif

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/* #ifndef __ALLOC_H
#include <alloc.h>
#endif */

int iadd_word( WSTR  *words, int *iMax, LPCSTR sWord )
{
	int i = *iMax;
 /*       */
 /*      */
  if( i >= WORDS_NUM_FILE )
    return WWAR_OVERFLOW;
 /*      */
  words[i].nIndex = i+1;
  if( sWord != NULL )
  {
    memcpy( (char *) words[i].sWord, (const char *) sWord, (size_t) WORD_SIZE );
    words[i].nFreq = 1;
    if( (strlen( (char *) sWord ) > 1) || (sWord[0] == 'I') )
      words[i].nStatus = WORD_UNKNOWN;
    else
      words[i].nStatus = WORD_OTHER;
  }
  else
      words[i].nStatus = WORD_NONE;

  *iMax = i + 1;
  return W_SUCCESS;
 /*  " " */
}

/***********************************************************
 *
 * Function ienable_create_WST
 *
 * This function checks if it is enabled to create arrays
 * of words in a memory.
 *
 *  ienable_create_WST
 *
 *     ,  
 *      .
 *
 *  :
 * 	.
 *
 *  :
 *
 *	W_SUCCESS	  --     
 *			      ;
 *	WERR_OVERFLOW --    .
 *
 *  :
 *
 * LocalCompact --	    
 *					   .
 *
************************************************************/

int ienable_create_WSTR( void )
{
	UINT ucheck;
	ucheck = LocalCompact( 0 );;
	if( ucheck > sizeof( WSTR) * WORDS_NUM_FILE )
		return W_SUCCESS;
	else
		return WERR_OVERFLOW;
}

/**********************************************************
 *
 * Function iadd_freq increases the frequency incoming
 * of current word on a value num
 *
 *     "" 
 *    .
 *
 *  :
 * words        --  "".
 * iMax         --    ""
 * i            --     ""
 * num          -- ""  (  1).
 *
 *  :
 * WWAR_OVERFLOW --      ""
 * WERR_OVERFLOW --      "".
 * WERR_DAMAGEDATA --     "".
 * W_SUCCESS --   ""    .
 *
 *  :
 *      .
 *
**********************************************************/

int iadd_freq( WSTR *words, int *iMax, int i, short num )
{

 /*       "" */

 if( *iMax >= WORDS_NUM_FILE )
    return WWAR_OVERFLOW;       /*  WWAR_OVERFLOW */

 /*       -  */

 if( i >= *iMax )
    return WERR_OVERFLOW;       /*  WWAR_OVERFLOW */

 /*     */

 if( words[i].sWord[0] == '\0' || words[i].nIndex == WORD_NONE )
   return WERR_DAMAGEDATA;      /*  WERR_DAMAGEDATA */

 /*    */

 words[i].nFreq += num;
 return W_SUCCESS;              /*    */
}

/**********************************************************
 *
 * Function icreate_WSTR creates the array of FreqDic
 * and initialise it.
 *
 *   -""  .
 *
 *  :
 * words        --  "".
 *
 *  :
 *   WERR_DAMAGEARRAY     --    
 *   W_SUCCESS            --  
 *
 *  :
 *   farcalloc
 *
**********************************************************/

int icreate_WSTR( HLOCAL *hwords )
{
   short n;
   WSTR *cwords;
   HLOCAL hcWords;

 /*     */

   hcWords = LocalAlloc( LHND, (UINT) WORDS_NUM_FILE*sizeof( WSTR ));
   
   /*    */

   if( hcWords == NULL ) return WERR_DAMAGEARRAY;
/*  WERR_DAMAGEARRAY     */

 /*    */

   cwords = (WSTR *) LocalLock( hcWords );
   if( cwords == NULL ) 
   {
		(void) LocalFree( hcWords );
		return WERR_DAMAGEARRAY;
	}

   for( n=0; n < WORDS_NUM_FILE; n++ )
   {
      cwords[n].nIndex = n+1;
      memset( (char *) cwords[n].sWord, '\0', WORD_SIZE);
      cwords[n].nFreq = 0;
      cwords[n].nStatus = WORD_NONE;
   }
   (void) LocalFree( hcWords );
   *hwords = hcWords;
   return W_SUCCESS;    /*  " " */
}

/*********************************************************
 *
 * Function idelete_WSTR deletes the array of FreqDic
 *
 *   -""   
 *
 *  :
 * words        --  "".
 *
 *  :
 *   W_SUCCESS            --  
 *
 *  :
 *   farfree
 *
**********************************************************/
int idelete_WSTR( HLOCAL *hwords )
{

 HLOCAL hcWords;
 hcWords = *hwords;

 /* : ""     */

   if( hcWords != NULL )
   {
		
 /*    */
 /*      ,    */

 /*  ,  "" */
     (void)LocalFree( hcWords );
   }
   *hwords = hcWords;
   return W_SUCCESS;    /*    */
}

/***********************************************************
 *
 * Function PrintTextOn_WSTR outputs the array of Frequency
 * Dictionary to output string
 *
 *   ""  " "
 *    ( CSV).
 *
 *  :
 *   words      --  "".
 *   fstream    --    .
 *
 *  :
 *   
 *
 *  :
 *   fputs, fprintf
 *
***********************************************************/
void PrintTextOn_WSTR( HLOCAL hwords, FILE *fstream )
{
  int i;
  WSTR *words;
  /*  */
  words = (WSTR *) LocalLock( hwords );
  if( words == NULL )
  {
	fputs( "\n\tDamage Output Data\n\t\tFatal Error Found\n\n", fstream );
	return;
  }
  
 /*   */

  fputs("\"NUMBER\";\"WORD\";\"FREQ\";\"STATUS\"\n", fstream );

 /*  ""    (  ,   ) */
  for( i = 0; i < WORDS_NUM_FILE; i++ )
    if( words[i].sWord[0] != '\0' )
      fprintf( fstream, "%d;\"%s\";%d;%d\n", words[i].nIndex, words[i].sWord, words[i].nFreq, words[i].nStatus );
  (void) LocalUnlock( hwords );
}

/***********************************************************
 *
 * Function ichecking_word_s checks the new word to presence
 * in a Frequency Dictionary, and add it if necessory.
 *
 *        
 * ""  " ",   
 *     .
 *
 *  :
 *   words      --  ""   ;
 *   iMax       --  ""  ;
 *   newstr     --   .
 *
 *  :
 *
 * W_SUCCESS --   ""    .
 * WWAR_OVERFLOW --      ""
 * WERR_NOWORDS --     "";
 * WERR_OVERFLOW --      "".
 * WERR_DAMAGEDATA --     "".
 * WWAR_NOWORDS --    ,   .
 *
 *    :
 *   icompare_words_s, iadd_freq, iadd_word.
 *
***********************************************************/

int ichecking_word_s( WSTR *words,  int  *iMax, LPCSTR newstr )
{

  int index;
  int istat = W_SUCCESS;
  int istat1 = W_SUCCESS;
  if( newstr != NULL)
  {
    if( newstr[0] ) /* If New word not empty, */
    {

 /*        */

      for( index = 0; index < *iMax; index++ )
      {

 /*     ""    */

		if( (istat = icompare_words_s( words, iMax, index, newstr ) ) == W_EQUAL )
		{

 /*     ,    */
 /*      */
 /*         */
 /*      : */
 /* icompare_words_s, */
 /* iadd_freq. */

			if( (istat1 = iadd_freq( words, iMax, index, 1 ) ) != W_SUCCESS)
			{
			    istat=istat1; goto M2;
			}
			break;
		}
 /*     ,  */
 /*  ,     */
 /*  W_SUCCESS      */
 /*   "" (   */

		else
			if( istat == W_LESS || istat == W_GREAT )
			{
				istat = W_SUCCESS;
				continue;
			}

 /*   index */

      }

 /*      "",    */
 /*    "" */

      if( index == *iMax )
	 if( ( istat = iadd_word( words, iMax, newstr ) ) != W_SUCCESS ) goto M2;

    }

 /*    ,  : */
 /* WERR_NOWORDS (  )      */

    else
      istat = WWAR_NOWORDS;

  }
  else
    istat = WWAR_NOWORDS;

  M2: return istat;
 /*       */

}

/*********************************************************************
 *
 * Function icompare_words_s simple compares the words and saved in
 * a array words.
 *
 *        ,
 *   "".
 *
 *  :
 * words        --  "".
 * iMax         --     ""
 * i            --     "".
 * sWord        --  .
 *
 *  :
 * WWAR_OVERFLOW --      ""
 * WERR_OVERFLOW --      "".
 * WERR_DAMAGEDATA --     "".
 * W_LESS --   "" ""  .
 * W_GREAT --   "" ""  .
 * W_EQUAL --   ""    .
 *
 *  :
 *      strncmp
 *
*********************************************************************/

int icompare_words_s( WSTR *words, int *iMax, int i, LPCSTR sWord )
{
 int istr;

 /*       "" */

 if( *iMax >= WORDS_NUM_FILE )
    return WWAR_OVERFLOW;       /*  WWAR_OVERFLOW */

 /*       -  */

 if( i >= *iMax )
    return WERR_OVERFLOW;      /*  WWAR_OVERFLOW */

 /*     */

 if( words[i].sWord[0] == '\0' || words[i].nIndex == WORD_NONE )
   return WERR_DAMAGEDATA;     /*  WERR_DAMAGEDATA */

 /*    */

 istr = strncmp( (char *) words[i].sWord, (char *) sWord, WORD_SIZE );

 /*    */

 if( istr < 0 ) return W_LESS;
 if( istr > 0 ) return W_GREAT;
 return W_EQUAL;
}

/***********************************************************
 *
 * Function ichecking_word checks the new word to presence
 * in a Frequency Dictionary, and add it if necessory.
 *
 *        
 * ""  " ",   
 *     .
 *
 *  :
 *   words      --  ""   ;
 *   iMax       --  ""  ;
 *   newstr     --   .
 * ilanguage    The Current Language (Russian, English or Both).
 * iCode_Tab    The Current Code Page (for Russian and both Russian/English Languages
 *
 *  :
 *
 * W_SUCCESS --   ""    .
 * WWAR_OVERFLOW --      ""
 * WERR_NOWORDS --     "";
 * WERR_OVERFLOW --      "".
 * WERR_DAMAGEDATA --     "".
 * WWAR_NOWORDS --    ,   .
 *
 *    :
 *   icompare_words, iadd_freq, iadd_word.
 *
***********************************************************/

int ichecking_word( WSTR *words,  int  *iMax, LPCSTR newstr, int ilanguage, int iCode_Tab)
{

  int index;
  int istat = W_SUCCESS;
  int istat1 = W_SUCCESS;
  if( newstr != NULL)
  {
    if( newstr[0] ) /* If New word not empty, */
    {

 /*        */

      for( index = 0; index < *iMax; index++ )
      {

 /*     ""    */

		if( (istat = icompare_words( words, iMax, index, newstr, ilanguage, iCode_Tab ) ) == W_EQUAL )
		{

 /*     ,    */
 /*      */
 /*         */
 /*      : */
 /* icompare_words_s, */
 /* iadd_freq. */

			if( (istat1 = iadd_freq( words, iMax, index, 1 ) ) != W_SUCCESS)
			{
			    istat=istat1; goto M2;
			}
			break;
		}
 /*     ,  */
 /*  ,     */
 /*  W_SUCCESS      */
 /*   "" (   */

		else
			if( istat == W_LESS || istat == W_GREAT )
			{
				istat = W_SUCCESS;
				continue;
			}

 /*   index */

      }

 /*      "",    */
 /*    "" */

      if( index == *iMax )
	 if( ( istat = iadd_word( words, iMax, newstr ) ) != W_SUCCESS ) goto M2;

    }

 /*    ,  : */
 /* WERR_NOWORDS (  )      */

    else
      istat = WWAR_NOWORDS;

  }
  else
    istat = WWAR_NOWORDS;

  M2: return istat;
 /*       */

}

/*********************************************************************
 *
 * Function icompare_words simple compares the words and saved in
 * a array words.
 *
 *        ,
 *   "".
 *
 *  :
 * words        --  "".
 * iMax         --     ""
 * i            --     "".
 * sWord        --  .
 * ilanguage    --  e (,  ).
 * iCode_Tab    --   (   /)
 *
 *  :
 * WWAR_OVERFLOW --      ""
 * WERR_OVERFLOW --      "".
 * WERR_DAMAGEDATA --     "".
 * W_LESS --   "" ""  .
 * W_GREAT --   "" ""  .
 * W_EQUAL --   ""    .
 *
 *  :
 *      strncmp
 *
*********************************************************************/

int icompare_words( WSTR *words, int *iMax, int i, LPCSTR sWord, int ilanguage, int iCode_Tab )
{
 int istr;

 /*       "" */

 if( *iMax >= WORDS_NUM_FILE )
    return WWAR_OVERFLOW;       /*  WWAR_OVERFLOW */

 /*       -  */

 if( i >= *iMax )
    return WERR_OVERFLOW;      /*  WWAR_OVERFLOW */

 /*     */

 if( words[i].sWord[0] == '\0' || words[i].nIndex == WORD_NONE )
   return WERR_DAMAGEDATA;     /*  WERR_DAMAGEDATA */

 /*    */

 istr = lstrcmp( (LPCSTR) words[i].sWord, (LPCSTR) sWord );

 /*    */

 if( istr < 0 ) return W_LESS;
 if( istr > 0 ) return W_GREAT;
 return W_EQUAL;
}

