/***********************************************************
 *
 * WSTR.H
 *
 * This is a file containing datas, function and definitions
 * for creating the Frequency Dictionary
 *
 *    ,    
 *   : " " ("FreqDict").
 *
***********************************************************/


#ifndef __WSTR_H
#define __WSTR_H

#ifndef __WINDOWS_H
#include <windows.h>
#endif

/* #ifndef __MEM_MODL_H
#include <mem_modl.h>
#endif */

#ifndef __WORDS0_H
#include "words0.h"
#endif

#ifndef __STDIO_H
#include <stdio.h>
#endif

#ifndef UCHAR
#define UCHAR unsigned char
#endif

/*   */

/***********************************************************
 *
 * Definition the Constants:
 *
 * NOTE: Prefix WWAR_ means that the events is a Warning, and
 * WERR_ means that the events is an Error, other events has
 * prefix W_
 *
 *  :
 *
 * :  WWAR_ ,    --
 * ,   WERR_ ,   
 * -- ,     W_.
 *
***********************************************************/

#ifndef WWAR_OVERFLOW     /* :  */
#define WWAR_OVERFLOW 2
#endif

#ifndef WERR_OVERFLOW     /* :  */
#define WERR_OVERFLOW -2
#endif

#ifndef WWAR_NOWORDS     /* :  */
#define WWAR_NOWORDS 5
#endif

#ifndef WERR_NOWORDS     /* :  */
#define WERR_NOWORDS -5
#endif

#ifndef WERR_DAMAGEDATA   /* :   */
#define WERR_DAMAGEDATA -3
#endif

#ifndef WERR_DAMAGEARRAY  /* :   */
#define WERR_DAMAGEARRAY -4
#endif

#ifndef W_SUCCESS       /*   (All Ok, Mum!)*/
#define W_SUCCESS 0
#endif

#ifndef W_EQUAL         /*   */
#define W_EQUAL 0
#endif

#ifndef W_LESS          /*  , ... */
#define W_LESS -1
#endif

#ifndef W_GREAT         /*  , ... */
#define W_GREAT 1
#endif

/***********************************************************
 *
 * Data sructure of a node of Frecuency Dictionary
 *
 * nIndex is a number of a word in an array;
 * sWord is a current word of an array;
 * nFreq is a frecuency of a word presenting in a text
 * nStatus is a code of speech part of the word
 *
 *     " ".
 *
 * nIndex --    
 * sWord --    
 * nFreq --     .
 * nStatus --     .
 *
***********************************************************/
typedef struct
{
  short nIndex;
  UCHAR sWord[WORD_SIZE];
  short nFreq;
  short nStatus;
} WSTR;

/*********************************************************
 *
 * Functions for operating a Data of a Frecuency
 * Dictionary array
 *
 *       
 * " ".
 *
*********************************************************/

/* Describe for C++ only */

#ifdef __cplusplus
extern "C" {
#endif

/* Manipulated with the words */

/*    */

int iadd_word( WSTR *, int *, LPCSTR );
int icompare_words_s( WSTR *, int *, int, LPCSTR );
int icompare_words( WSTR *, int *, int, LPCSTR, int, int );
int iadd_freq( WSTR *, int *, int, short );
int ichecking_word_s( WSTR *, int *, LPCSTR );
int ichecking_word( WSTR *, int *, LPCSTR, int, int );

/* Creating/Deleting the Words Frecuency Dictionary array */

/* /     */

int ienable_create_WSTR( void );
int icreate_WSTR( HLOCAL * );
int idelete_WSTR( HLOCAL * );

/* Input/Output the array */

/* /  */

void PrintTextOn_WSTR( HLOCAL, FILE * );

/* Describe for C++ only */

#ifdef __cplusplus
}
#endif

#endif
